Summary:	A C++ interface for glib library - cross MinGW32 version
Summary(pl.UTF-8):	Interfejs C++ dla biblioteki glib - wersja skrośna MinGW32
%define		realname	glibmm
Name:		crossmingw32-%{realname}
Version:	2.58.0
Release:	2
License:	LGPL v2+
Group:		Development/Libraries
Source0:	http://ftp.gnome.org/pub/GNOME/sources/glibmm/2.58/%{realname}-%{version}.tar.xz
# Source0-md5:	4a0402ac65a7c47424b4e21b81b079c0
Patch0:		glibmm-mingw32.patch
URL:		http://www.gtkmm.org/
BuildRequires:	autoconf >= 2.59
BuildRequires:	automake >= 1:1.11
BuildRequires:	crossmingw32-gcc-c++ >= 1:4.7
BuildRequires:	crossmingw32-glib2 >= 2.56.0
BuildRequires:	crossmingw32-libsigc++ >= 2.10.0
BuildRequires:	crossmingw32-std-threads
BuildRequires:	libtool >= 2:2.0
BuildRequires:	m4
BuildRequires:	mm-common >= 0.9.10
BuildRequires:	pkgconfig >= 1:0.15
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
Requires:	crossmingw32-gcc-c++ >= 1:4.7
Requires:	crossmingw32-glib2 >= 2.56.0
Requires:	crossmingw32-libsigc++ >= 2.10.0
Requires:	crossmingw32-std-threads
ExcludeArch:	i386
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1

%define		target			i386-mingw32
%define		target_platform 	i386-pc-mingw32

%define		_sysprefix		/usr
%define		_prefix			%{_sysprefix}/%{target}
%define		_libdir			%{_prefix}/lib
%define		_pkgconfigdir		%{_prefix}/lib/pkgconfig
%define		_dlldir			/usr/share/wine/windows/system
%define		__cc			%{target}-gcc
%define		__cxx			%{target}-g++
%define		__pkgconfig_provides	%{nil}
%define		__pkgconfig_requires	%{nil}

%ifnarch %{ix86}
# arch-specific flags (like alpha's -mieee) are not valid for i386 gcc
# now at least i486 is required for atomic operations
%define		optflags	-O2 -march=i486
%endif
# -z options are invalid for mingw linker, most of -f options are Linux-specific
%define		filterout_ld	-Wl,-z,.*
%define		filterout_c	-f[-a-z0-9=]*
%define		filterout_cxx	-f[-a-z0-9=]*

%description
A C++ interface for glib library - cross MinGW32 version.

%description -l pl.UTF-8
Interfejs C++ dla biblioteki glib - wersja skrośna MinGW32.

%package static
Summary:	Static glibmm library (cross MinGW32 version)
Summary(pl.UTF-8):	Statyczna biblioteka glibmm (wersja skrośna MinGW32)
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description static
Static glibmm library (cross MinGW32 version).

%description static -l pl.UTF-8
Statyczna biblioteka glibmm (wersja skrośna MinGW32).

%package dll
Summary:	DLL glibmm library for Windows
Summary(pl.UTF-8):	Biblioteka DLL glibmm dla Windows
Group:		Applications/Emulators
Requires:	crossmingw32-glib2-dll >= 2.56.0
Requires:	crossmingw32-libsigc++-dll >= 2.10.0
Requires:	wine

%description dll
DLL glibmm library for Windows.

%description dll -l pl.UTF-8
Biblioteka DLL glibmm dla Windows.

%prep
%setup -q -n %{realname}-%{version}
%patch0 -p1

%build
export PKG_CONFIG_LIBDIR=%{_prefix}/lib/pkgconfig
%{__libtoolize}
%{__aclocal} -I build
%{__autoconf}
%{__automake}
# std-threads require at least WinXP API
CPPFLAGS="%{rpmcppflags} -DWINVER=0x0501"
# mingw32 requires gnu++11 (instead of c++11) for off[64]_t
CXXFLAGS="%{rpmcxxflags} -std=gnu++11"
%configure \
	--target=%{target} \
	--host=%{target} \
	--disable-fulldocs \
	--disable-silent-rules \
	--enable-static

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_dlldir}
%{__mv} $RPM_BUILD_ROOT%{_prefix}/bin/*.dll $RPM_BUILD_ROOT%{_dlldir}

%if 0%{!?debug:1}
%{target}-strip --strip-unneeded -R.comment -R.note $RPM_BUILD_ROOT%{_dlldir}/*.dll
%{target}-strip -g -R.comment -R.note $RPM_BUILD_ROOT%{_libdir}/*.a
%endif

%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/{doc,devhelp}
# use these from native glibmm if needed
%{__rm} -r $RPM_BUILD_ROOT%{_libdir}/glibmm-2.4/proc

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog NEWS README
%{_libdir}/libgiomm-2.4.dll.a
%{_libdir}/libglibmm-2.4.dll.a
%{_libdir}/libglibmm_generate_extra_defs-2.4.dll.a
%{_libdir}/libgiomm-2.4.la
%{_libdir}/libglibmm-2.4.la
%{_libdir}/libglibmm_generate_extra_defs-2.4.la
%dir %{_libdir}/giomm-2.4
%{_libdir}/giomm-2.4/include
%dir %{_libdir}/glibmm-2.4
%{_libdir}/glibmm-2.4/include
%{_includedir}/giomm-2.4
%{_includedir}/glibmm-2.4
%{_pkgconfigdir}/giomm-2.4.pc
%{_pkgconfigdir}/glibmm-2.4.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libgiomm-2.4.a
%{_libdir}/libglibmm-2.4.a
%{_libdir}/libglibmm_generate_extra_defs-2.4.a

%files dll
%defattr(644,root,root,755)
%{_dlldir}/libgiomm-2.4-*.dll
%{_dlldir}/libglibmm-2.4-*.dll
%{_dlldir}/libglibmm_generate_extra_defs-2.4-*.dll
%changelog
* Sat Dec 22 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/crossmingw32-glibmm.git;a=log;h=master

* Sat Dec 22 2018 Jakub Bogusz <qboosh@pld-linux.org> 699199a
- release 2

* Thu Nov 08 2018 Jakub Bogusz <qboosh@pld-linux.org> 317dc93
- updated to 2.58.0

* Fri Oct 05 2018 Jakub Bogusz <qboosh@pld-linux.org> a99b542
- requires i486 atomic operations; release 2

* Fri Oct 05 2018 Jakub Bogusz <qboosh@pld-linux.org> 7bc3f17
- updated to 2.56.0

* Wed Jun 28 2017 Jakub Bogusz <qboosh@pld-linux.org> a69449b
- updated to 2.52.0

* Sun Mar 05 2017 Jakub Bogusz <qboosh@pld-linux.org> bbdb45e
- release 2

* Sat Dec 03 2016 Jakub Bogusz <qboosh@pld-linux.org> 4d8dada
- updated to 1.50.0

* Sat Jun 25 2016 Jakub Bogusz <qboosh@pld-linux.org> 15f7ed6
- updated to 2.48.1
- added mingw32 patch, use meganz mingw-std-threads for std::mutex

* Thu Dec 24 2015 Jakub Bogusz <qboosh@pld-linux.org> 4b05efa
- updated to 2.46.3

* Mon Nov 23 2015 Jakub Bogusz <qboosh@pld-linux.org> 0844886
- updated to 2.46.2

* Tue Sep 29 2015 Jakub Bogusz <qboosh@pld-linux.org> b6e3aa7
- updated to 2.46.1; C++11 now
- mingw32 requires -std=gnu++11 instead of c++11

* Wed Apr 22 2015 Jakub Bogusz <qboosh@pld-linux.org> 86e6b20
- updated to 2.44.0

* Fri Oct 10 2014 Jakub Bogusz <qboosh@pld-linux.org> 6b64692
- updated to 2.42.0

* Tue Apr 15 2014 Jakub Bogusz <qboosh@pld-linux.org> a16093a
- updated to 2.40.0
- removed obsolete win32 patch

* Mon Nov 18 2013 Jakub Bogusz <qboosh@pld-linux.org> 1a95c32
- updated to 2.38.1

* Sun Oct 20 2013 Jakub Bogusz <qboosh@pld-linux.org> 96f6c57
- updated to 2.38.0

* Sun Jun 09 2013 Jakub Bogusz <qboosh@pld-linux.org> 4649387
- updated to 2.36.2

* Sat Apr 20 2013 Elan Ruusamäe <glen@delfi.ee> be43f55
- do not require pkgconfig deps either

* Sat Apr 20 2013 Elan Ruusamäe <glen@delfi.ee> de0bc54
- do not provide pkgconfig deps in system namespace

* Thu Apr 18 2013 Jakub Bogusz <qboosh@pld-linux.org> e882ae3
- updated filterout_

